diff --git a/CMakeLists.txt b/CMakeLists.txt
index c96b45478..b4753a7bf 100644
--- a/CMakeLists.txt
+++ b/CMakeLists.txt
@@ -102,6 +102,7 @@ set (czmq_headers
     include/zdigest.h
     include/zdir.h
     include/zdir_patch.h
+    include/zdir_watch.h
     include/zfile.h
     include/zframe.h
     include/zgossip.h
@@ -155,6 +156,7 @@ set (czmq_sources
     src/zdigest.c
     src/zdir.c
     src/zdir_patch.c
+    src/zdir_watch.c
     src/zfile.c
     src/zframe.c
     src/zgossip.c
diff --git a/api/zdir_watch.xml b/api/zdir_watch.xml
new file mode 100644
index 000000000..8518ad8a9
--- /dev/null
+++ b/api/zdir_watch.xml
@@ -0,0 +1,39 @@
+<class name="zdir watch">
+    Watch a directory tree
+
+    <constructor exclude="1" />
+    <destructor exclude="1" />
+    <method name="print" exclude="1" />
+
+    <method name="actor" singleton="1">
+        Create a new zdir_watch actor instance:
+
+            zactor_t *watch = zactor_new (zdir_watch_actor, NULL);
+
+        Destroy zdir_watch instance:
+
+            zactor_destroy (&amp;watch);
+
+        Enable verbose logging of commands and activity:
+
+            zstr_send (watch, "VERBOSE");
+
+        Subscribe to changes to a directory path:
+
+            zsock_send (watch, "ss", "SUBSCRIBE", "directory_path");
+
+        Unsubscribe from changes to a directory path:
+
+            zsock_send (watch, "ss", "UNSUBSCRIBE", "directory_path");
+
+        Receive directory changes:
+            zsock_recv (watch, "sp", &amp;path, &amp;patches);
+
+            // Delete the received data.
+            free (path);
+            zlist_destroy (&amp;patches);
+        <argument name="pipe" type="zsock" />
+        <argument name="unused" type="anything" />
+    </method>
+
+</class>
diff --git a/bindings/python/czmq.py b/bindings/python/czmq.py
index 9e2b4ce4d..30de6246e 100644
--- a/bindings/python/czmq.py
+++ b/bindings/python/czmq.py
@@ -51,6 +51,10 @@ class zdir_patch_t(Structure):
     pass # Empty - only for type checking
 zdir_patch_p = POINTER(zdir_patch_t)
 
+class zsock_t(Structure):
+    pass # Empty - only for type checking
+zsock_p = POINTER(zsock_t)
+
 class zchunk_t(Structure):
     pass # Empty - only for type checking
 zchunk_p = POINTER(zchunk_t)
@@ -67,10 +71,6 @@ class zloop_t(Structure):
     pass # Empty - only for type checking
 zloop_p = POINTER(zloop_t)
 
-class zsock_t(Structure):
-    pass # Empty - only for type checking
-zsock_p = POINTER(zsock_t)
-
 class zmq_pollitem_t(Structure):
     pass # Empty - only for type checking
 zmq_pollitem_p = POINTER(zmq_pollitem_t)
@@ -322,6 +322,51 @@ def test(verbose):
         return lib.zdir_patch_test(verbose)
 
 
+# zdir watch
+lib.zdir_watch_actor.restype = None
+lib.zdir_watch_actor.argtypes = [zsock_p, c_void_p]
+lib.zdir_watch_test.restype = None
+lib.zdir_watch_test.argtypes = [c_bool]
+
+class ZdirWatch(object):
+    """Watch a directory tree"""
+
+    @staticmethod
+    def actor(pipe, unused):
+        """Create a new zdir_watch actor instance:
+
+    zactor_t *watch = zactor_new (zdir_watch_actor, NULL);
+
+Destroy zdir_watch instance:
+
+    zactor_destroy (&watch);
+
+Enable verbose logging of commands and activity:
+
+    zstr_send (watch, "VERBOSE");
+
+Subscribe to changes to a directory path:
+
+    zsock_send (watch, "ss", "SUBSCRIBE", "directory_path");
+
+Unsubscribe from changes to a directory path:
+
+    zsock_send (watch, "ss", "UNSUBSCRIBE", "directory_path");
+
+Receive directory changes:
+    zsock_recv (watch, "sp", &path, &patches);
+
+    // Delete the received data.
+    free (path);
+    zlist_destroy (&patches);"""
+        return lib.zdir_watch_actor(pipe, unused)
+
+    @staticmethod
+    def test(verbose):
+        """Self test of this class."""
+        return lib.zdir_watch_test(verbose)
+
+
 # zfile
 lib.zfile_new.restype = zfile_p
 lib.zfile_new.argtypes = [c_char_p, c_char_p]
diff --git a/bindings/qml/qml_czmq_bindings.pro b/bindings/qml/qml_czmq_bindings.pro
index 7052422d4..4355bbc02 100644
--- a/bindings/qml/qml_czmq_bindings.pro
+++ b/bindings/qml/qml_czmq_bindings.pro
@@ -40,6 +40,7 @@ HEADERS += \
   $$SRCDIR/qml_czmq_plugin.h \
   $$SRCDIR/QmlZdir.h \
   $$SRCDIR/QmlZdirPatch.h \
+  $$SRCDIR/QmlZdirWatch.h \
   $$SRCDIR/QmlZfile.h \
   $$SRCDIR/QmlZframe.h \
   $$SRCDIR/QmlZiflist.h \
@@ -52,6 +53,7 @@ HEADERS += \
 SOURCES += \
   $$SRCDIR/QmlZdir.cpp \
   $$SRCDIR/QmlZdirPatch.cpp \
+  $$SRCDIR/QmlZdirWatch.cpp \
   $$SRCDIR/QmlZfile.cpp \
   $$SRCDIR/QmlZframe.cpp \
   $$SRCDIR/QmlZiflist.cpp \
diff --git a/bindings/qml/src/QmlZdirWatch.cpp b/bindings/qml/src/QmlZdirWatch.cpp
new file mode 100644
index 000000000..831bed005
--- /dev/null
+++ b/bindings/qml/src/QmlZdirWatch.cpp
@@ -0,0 +1,59 @@
+/*
+################################################################################
+#  THIS FILE IS 100% GENERATED BY ZPROJECT; DO NOT EDIT EXCEPT EXPERIMENTALLY  #
+#  Please refer to the README for information about making permanent changes.  #
+################################################################################
+*/
+
+#include "QmlZdirWatch.h"
+
+
+
+QObject* QmlZdirWatch::qmlAttachedProperties(QObject* object) {
+    return new QmlZdirWatchAttached(object);
+}
+
+
+///
+//  Create a new zdir_watch actor instance:                       
+//                                                                
+//      zactor_t *watch = zactor_new (zdir_watch_actor, NULL);    
+//                                                                
+//  Destroy zdir_watch instance:                                  
+//                                                                
+//      zactor_destroy (&watch);                                  
+//                                                                
+//  Enable verbose logging of commands and activity:              
+//                                                                
+//      zstr_send (watch, "VERBOSE");                             
+//                                                                
+//  Subscribe to changes to a directory path:                     
+//                                                                
+//      zsock_send (watch, "ss", "SUBSCRIBE", "directory_path");  
+//                                                                
+//  Unsubscribe from changes to a directory path:                 
+//                                                                
+//      zsock_send (watch, "ss", "UNSUBSCRIBE", "directory_path");
+//                                                                
+//  Receive directory changes:                                    
+//      zsock_recv (watch, "sp", &path, &patches);                
+//                                                                
+//      // Delete the received data.                              
+//      free (path);                                              
+//      zlist_destroy (&patches);                                 
+void QmlZdirWatchAttached::actor (QmlZsock *pipe, void *unused) {
+    zdir_watch_actor (pipe->self, unused);
+};
+
+///
+//  Self test of this class.
+void QmlZdirWatchAttached::test (bool verbose) {
+    zdir_watch_test (verbose);
+};
+
+/*
+################################################################################
+#  THIS FILE IS 100% GENERATED BY ZPROJECT; DO NOT EDIT EXCEPT EXPERIMENTALLY  #
+#  Please refer to the README for information about making permanent changes.  #
+################################################################################
+*/
diff --git a/bindings/qml/src/QmlZdirWatch.h b/bindings/qml/src/QmlZdirWatch.h
new file mode 100644
index 000000000..218993271
--- /dev/null
+++ b/bindings/qml/src/QmlZdirWatch.h
@@ -0,0 +1,84 @@
+/*
+################################################################################
+#  THIS FILE IS 100% GENERATED BY ZPROJECT; DO NOT EDIT EXCEPT EXPERIMENTALLY  #
+#  Please refer to the README for information about making permanent changes.  #
+################################################################################
+*/
+
+#ifndef QML_ZDIR_WATCH_H
+#define QML_ZDIR_WATCH_H
+
+#include <QtQml>
+
+#include <czmq.h>
+#include "qml_czmq_plugin.h"
+
+
+class QmlZdirWatch : public QObject
+{
+    Q_OBJECT
+    Q_PROPERTY(bool isNULL READ isNULL)
+    
+public:
+    zdir_watch_t *self;
+    
+    QmlZdirWatch() { self = NULL; }
+    bool isNULL() { return self == NULL; }
+    
+    static QObject* qmlAttachedProperties(QObject* object); // defined in QmlZdirWatch.cpp
+    
+public slots:};
+
+class QmlZdirWatchAttached : public QObject
+{
+    Q_OBJECT
+    QObject* m_attached;
+    
+public:
+    QmlZdirWatchAttached (QObject* attached) {
+        Q_UNUSED (attached);
+    };
+    
+public slots:
+    //  Create a new zdir_watch actor instance:                       
+    //                                                                
+    //      zactor_t *watch = zactor_new (zdir_watch_actor, NULL);    
+    //                                                                
+    //  Destroy zdir_watch instance:                                  
+    //                                                                
+    //      zactor_destroy (&watch);                                  
+    //                                                                
+    //  Enable verbose logging of commands and activity:              
+    //                                                                
+    //      zstr_send (watch, "VERBOSE");                             
+    //                                                                
+    //  Subscribe to changes to a directory path:                     
+    //                                                                
+    //      zsock_send (watch, "ss", "SUBSCRIBE", "directory_path");  
+    //                                                                
+    //  Unsubscribe from changes to a directory path:                 
+    //                                                                
+    //      zsock_send (watch, "ss", "UNSUBSCRIBE", "directory_path");
+    //                                                                
+    //  Receive directory changes:                                    
+    //      zsock_recv (watch, "sp", &path, &patches);                
+    //                                                                
+    //      // Delete the received data.                              
+    //      free (path);                                              
+    //      zlist_destroy (&patches);                                 
+    void actor (QmlZsock *pipe, void *unused);
+
+    //  Self test of this class.
+    void test (bool verbose);
+};
+
+
+QML_DECLARE_TYPEINFO(QmlZdirWatch, QML_HAS_ATTACHED_PROPERTIES)
+
+#endif
+/*
+################################################################################
+#  THIS FILE IS 100% GENERATED BY ZPROJECT; DO NOT EDIT EXCEPT EXPERIMENTALLY  #
+#  Please refer to the README for information about making permanent changes.  #
+################################################################################
+*/
diff --git a/bindings/qml/src/qml_czmq_plugin.h b/bindings/qml/src/qml_czmq_plugin.h
index 26b760b10..ac43308ab 100644
--- a/bindings/qml/src/qml_czmq_plugin.h
+++ b/bindings/qml/src/qml_czmq_plugin.h
@@ -15,6 +15,8 @@ class QmlZdir;
 class QmlZdirAttached;
 class QmlZdirPatch;
 class QmlZdirPatchAttached;
+class QmlZdirWatch;
+class QmlZdirWatchAttached;
 class QmlZfile;
 class QmlZfileAttached;
 class QmlZframe;
@@ -34,6 +36,7 @@ class QmlZlistAttached;
 
 #include "QmlZdir.h"
 #include "QmlZdirPatch.h"
+#include "QmlZdirWatch.h"
 #include "QmlZfile.h"
 #include "QmlZframe.h"
 #include "QmlZiflist.h"
@@ -55,6 +58,8 @@ class QmlCZMQPlugin : public QQmlExtensionPlugin
         qmlRegisterType<QmlZdirAttached>();
         qmlRegisterType<QmlZdirPatch> (uri, 1, 0, "QmlZdirPatch");
         qmlRegisterType<QmlZdirPatchAttached>();
+        qmlRegisterType<QmlZdirWatch> (uri, 1, 0, "QmlZdirWatch");
+        qmlRegisterType<QmlZdirWatchAttached>();
         qmlRegisterType<QmlZfile> (uri, 1, 0, "QmlZfile");
         qmlRegisterType<QmlZfileAttached>();
         qmlRegisterType<QmlZframe> (uri, 1, 0, "QmlZframe");
diff --git a/bindings/ruby/lib/czmq/ffi.rb b/bindings/ruby/lib/czmq/ffi.rb
index 4d3a27592..f7a244443 100644
--- a/bindings/ruby/lib/czmq/ffi.rb
+++ b/bindings/ruby/lib/czmq/ffi.rb
@@ -64,6 +64,11 @@ def self.available?
       
       require_relative 'ffi/zdir_patch'
       
+      attach_function :zdir_watch_actor, [:pointer, :pointer], :void, **opts
+      attach_function :zdir_watch_test, [:bool], :void, **opts
+      
+      require_relative 'ffi/zdir_watch'
+      
       attach_function :zfile_new, [:string, :string], :pointer, **opts
       attach_function :zfile_destroy, [:pointer], :void, **opts
       attach_function :zfile_dup, [:pointer], :pointer, **opts
diff --git a/bindings/ruby/lib/czmq/ffi/zdir_watch.rb b/bindings/ruby/lib/czmq/ffi/zdir_watch.rb
new file mode 100644
index 000000000..b76ea969c
--- /dev/null
+++ b/bindings/ruby/lib/czmq/ffi/zdir_watch.rb
@@ -0,0 +1,98 @@
+################################################################################
+#  THIS FILE IS 100% GENERATED BY ZPROJECT; DO NOT EDIT EXCEPT EXPERIMENTALLY  #
+#  Please refer to the README for information about making permanent changes.  #
+################################################################################
+
+module CZMQ
+  module FFI
+    
+    # Watch a directory tree
+    class ZdirWatch
+      class DestroyedError < RuntimeError; end
+      
+      # Boilerplate for self pointer, initializer, and finalizer
+      class << self
+        alias :__new :new
+      end
+      def initialize ptr, finalize=true
+        @ptr = ptr
+        if @ptr.null?
+          @ptr = nil # Remove null pointers so we don't have to test for them.
+        elsif finalize
+          @finalizer = self.class.send :create_finalizer_for, @ptr
+          ObjectSpace.define_finalizer self, @finalizer
+        end
+      end
+      def self.create_finalizer_for ptr
+        Proc.new do
+          "WARNING: "\
+          "Objects of type #{self} cannot be destroyed implicitly. "\
+          "Please call the correct destroy method with the relevant arguments."
+        end
+      end
+      def null?
+        !@ptr or ptr.null?
+      end
+      # Return internal pointer
+      def __ptr
+        raise DestroyedError unless @ptr
+        @ptr
+      end
+      # Nullify internal pointer and return pointer pointer
+      def __ptr_give_ref
+        raise DestroyedError unless @ptr
+        ptr_ptr = ::FFI::MemoryPointer.new :pointer
+        ptr_ptr.write_pointer @ptr
+        ObjectSpace.undefine_finalizer self if @finalizer
+        @finalizer = nil
+        @ptr = nil
+        ptr_ptr
+      end
+      
+      # Create a new zdir_watch actor instance:                       
+      #                                                               
+      #     zactor_t *watch = zactor_new (zdir_watch_actor, NULL);    
+      #                                                               
+      # Destroy zdir_watch instance:                                  
+      #                                                               
+      #     zactor_destroy (&watch);                                  
+      #                                                               
+      # Enable verbose logging of commands and activity:              
+      #                                                               
+      #     zstr_send (watch, "VERBOSE");                             
+      #                                                               
+      # Subscribe to changes to a directory path:                     
+      #                                                               
+      #     zsock_send (watch, "ss", "SUBSCRIBE", "directory_path");  
+      #                                                               
+      # Unsubscribe from changes to a directory path:                 
+      #                                                               
+      #     zsock_send (watch, "ss", "UNSUBSCRIBE", "directory_path");
+      #                                                               
+      # Receive directory changes:                                    
+      #     zsock_recv (watch, "sp", &path, &patches);                
+      #                                                               
+      #     // Delete the received data.                              
+      #     free (path);                                              
+      #     zlist_destroy (&patches);                                 
+      def self.actor pipe, unused
+        pipe = pipe.__ptr if pipe
+        result = ::CZMQ::FFI.zdir_watch_actor pipe, unused
+        result
+      end
+      
+      # Self test of this class.
+      def self.test verbose
+        verbose = !(0==verbose||!verbose) # boolean
+        result = ::CZMQ::FFI.zdir_watch_test verbose
+        result
+      end
+    end
+    
+  end
+end
+
+################################################################################
+#  THIS FILE IS 100% GENERATED BY ZPROJECT; DO NOT EDIT EXCEPT EXPERIMENTALLY  #
+#  Please refer to the README for information about making permanent changes.  #
+################################################################################
diff --git a/builds/android/Android.mk b/builds/android/Android.mk
index aa8a61e8b..2120295f5 100644
--- a/builds/android/Android.mk
+++ b/builds/android/Android.mk
@@ -20,7 +20,7 @@ include $(PREBUILT_SHARED_LIBRARY)
 include $(CLEAR_VARS)
 LOCAL_MODULE := czmq
 LOCAL_C_INCLUDES := ../../include $(LIBZMQ)/include
-LOCAL_SRC_FILES := zactor.c zauth.c zarmour.c zbeacon.c zcert.c zcertstore.c zchunk.c zclock.c zconfig.c zdigest.c zdir.c zdir_patch.c zfile.c zframe.c zgossip.c zhashx.c ziflist.c zlistx.c zloop.c zmonitor.c zmsg.c zpoller.c zproxy.c zrex.c zsock.c zsock_option.c zstr.c zsys.c zuuid.c zgossip_msg.c zauth_v2.c zbeacon_v2.c zctx.c zhash.c zlist.c zmonitor_v2.c zmutex.c zproxy_v2.c zsocket.c zsockopt.c zthread.c
+LOCAL_SRC_FILES := zactor.c zauth.c zarmour.c zbeacon.c zcert.c zcertstore.c zchunk.c zclock.c zconfig.c zdigest.c zdir.c zdir_patch.c zdir_watch.c zfile.c zframe.c zgossip.c zhashx.c ziflist.c zlistx.c zloop.c zmonitor.c zmsg.c zpoller.c zproxy.c zrex.c zsock.c zsock_option.c zstr.c zsys.c zuuid.c zgossip_msg.c zauth_v2.c zbeacon_v2.c zctx.c zhash.c zlist.c zmonitor_v2.c zmutex.c zproxy_v2.c zsocket.c zsockopt.c zthread.c
 LOCAL_SHARED_LIBRARIES := zmq
 include $(BUILD_SHARED_LIBRARY)
 
diff --git a/builds/cygwin/Makefile.cygwin b/builds/cygwin/Makefile.cygwin
index 6ac535f9b..94178b518 100755
--- a/builds/cygwin/Makefile.cygwin
+++ b/builds/cygwin/Makefile.cygwin
@@ -10,7 +10,7 @@ INCDIR=-I$(PREFIX)/include -I.
 LIBDIR=-L$(PREFIX)/lib
 CFLAGS=-Wall -Os -g -DLIBCZMQ_EXPORTS $(INCDIR)
 
-OBJS = zactor.o zauth.o zarmour.o zbeacon.o zcert.o zcertstore.o zchunk.o zclock.o zconfig.o zdigest.o zdir.o zdir_patch.o zfile.o zframe.o zgossip.o zhashx.o ziflist.o zlistx.o zloop.o zmonitor.o zmsg.o zpoller.o zproxy.o zrex.o zsock.o zsock_option.o zstr.o zsys.o zuuid.o zgossip_msg.o zauth_v2.o zbeacon_v2.o zctx.o zhash.o zlist.o zmonitor_v2.o zmutex.o zproxy_v2.o zsocket.o zsockopt.o zthread.o
+OBJS = zactor.o zauth.o zarmour.o zbeacon.o zcert.o zcertstore.o zchunk.o zclock.o zconfig.o zdigest.o zdir.o zdir_patch.o zdir_watch.o zfile.o zframe.o zgossip.o zhashx.o ziflist.o zlistx.o zloop.o zmonitor.o zmsg.o zpoller.o zproxy.o zrex.o zsock.o zsock_option.o zstr.o zsys.o zuuid.o zgossip_msg.o zauth_v2.o zbeacon_v2.o zctx.o zhash.o zlist.o zmonitor_v2.o zmutex.o zproxy_v2.o zsocket.o zsockopt.o zthread.o
 %.o: ../../src/%.c
 	$(CC) -c -o $@ $< $(CFLAGS)
 
diff --git a/builds/mingw32/Makefile.mingw32 b/builds/mingw32/Makefile.mingw32
index 9dffb2d61..fba2d763d 100644
--- a/builds/mingw32/Makefile.mingw32
+++ b/builds/mingw32/Makefile.mingw32
@@ -10,7 +10,7 @@ INCDIR=-I$(PREFIX)/include -I.
 LIBDIR=-L$(PREFIX)/lib
 CFLAGS=-Wall -Os -g -DLIBCZMQ_EXPORTS $(INCDIR)
 
-OBJS = zactor.o zauth.o zarmour.o zbeacon.o zcert.o zcertstore.o zchunk.o zclock.o zconfig.o zdigest.o zdir.o zdir_patch.o zfile.o zframe.o zgossip.o zhashx.o ziflist.o zlistx.o zloop.o zmonitor.o zmsg.o zpoller.o zproxy.o zrex.o zsock.o zsock_option.o zstr.o zsys.o zuuid.o zgossip_msg.o zauth_v2.o zbeacon_v2.o zctx.o zhash.o zlist.o zmonitor_v2.o zmutex.o zproxy_v2.o zsocket.o zsockopt.o zthread.o
+OBJS = zactor.o zauth.o zarmour.o zbeacon.o zcert.o zcertstore.o zchunk.o zclock.o zconfig.o zdigest.o zdir.o zdir_patch.o zdir_watch.o zfile.o zframe.o zgossip.o zhashx.o ziflist.o zlistx.o zloop.o zmonitor.o zmsg.o zpoller.o zproxy.o zrex.o zsock.o zsock_option.o zstr.o zsys.o zuuid.o zgossip_msg.o zauth_v2.o zbeacon_v2.o zctx.o zhash.o zlist.o zmonitor_v2.o zmutex.o zproxy_v2.o zsocket.o zsockopt.o zthread.o
 %.o: ../../src/%.c
 	$(CC) -c -o $@ $< $(CFLAGS)
 
diff --git a/builds/msvc/vs2008/czmq/czmq.vcproj b/builds/msvc/vs2008/czmq/czmq.vcproj
index 26d7cd9ef..6bde3307d 100644
--- a/builds/msvc/vs2008/czmq/czmq.vcproj
+++ b/builds/msvc/vs2008/czmq/czmq.vcproj
@@ -582,6 +582,38 @@
           <Tool Name="VCCLCompilerTool" CompileAs="2" />
         </FileConfiguration>
       </File>
+      <File RelativePath="..\..\..\..\src\zdir_watch.c">
+        <FileConfiguration Name="Release|Win32">
+          <Tool Name="VCCLCompilerTool" CompileAs="2" />
+        </FileConfiguration>
+        <FileConfiguration Name="Release|x64">
+          <Tool Name="VCCLCompilerTool" CompileAs="2" />
+        </FileConfiguration>
+        <FileConfiguration Name="Debug|Win32">
+          <Tool Name="VCCLCompilerTool" CompileAs="2" />
+        </FileConfiguration>
+        <FileConfiguration Name="Debug|x64">
+          <Tool Name="VCCLCompilerTool" CompileAs="2" />
+        </FileConfiguration>
+        <FileConfiguration Name="DebugDLL|Win32">
+          <Tool Name="VCCLCompilerTool" CompileAs="2" />
+        </FileConfiguration>
+        <FileConfiguration Name="DebugDLL|x64">
+          <Tool Name="VCCLCompilerTool" CompileAs="2" />
+        </FileConfiguration>
+        <FileConfiguration Name="ReleaseDLL|Win32">
+          <Tool Name="VCCLCompilerTool" CompileAs="2" />
+        </FileConfiguration>
+        <FileConfiguration Name="ReleaseDLL|x64">
+          <Tool Name="VCCLCompilerTool" CompileAs="2" />
+        </FileConfiguration>
+        <FileConfiguration Name="RelWithDebInfo|Win32">
+          <Tool Name="VCCLCompilerTool" CompileAs="2" />
+        </FileConfiguration>
+        <FileConfiguration Name="RelWithDebInfo|x64">
+          <Tool Name="VCCLCompilerTool" CompileAs="2" />
+        </FileConfiguration>
+      </File>
       <File RelativePath="..\..\..\..\src\zfile.c">
         <FileConfiguration Name="Release|Win32">
           <Tool Name="VCCLCompilerTool" CompileAs="2" />
@@ -1525,6 +1557,7 @@
       <File RelativePath="..\..\..\..\include\zdigest.h" />
       <File RelativePath="..\..\..\..\include\zdir.h" />
       <File RelativePath="..\..\..\..\include\zdir_patch.h" />
+      <File RelativePath="..\..\..\..\include\zdir_watch.h" />
       <File RelativePath="..\..\..\..\include\zfile.h" />
       <File RelativePath="..\..\..\..\include\zframe.h" />
       <File RelativePath="..\..\..\..\include\zgossip.h" />
diff --git a/builds/msvc/vs2010/czmq/czmq.vcxproj b/builds/msvc/vs2010/czmq/czmq.vcxproj
index 045558d28..cd4036352 100644
--- a/builds/msvc/vs2010/czmq/czmq.vcxproj
+++ b/builds/msvc/vs2010/czmq/czmq.vcxproj
@@ -121,6 +121,9 @@
     <ClCompile Include="..\..\..\..\src\zdir_patch.c">
       <CompileAs>CompileAsCpp</CompileAs>
     </ClCompile>
+    <ClCompile Include="..\..\..\..\src\zdir_watch.c">
+      <CompileAs>CompileAsCpp</CompileAs>
+    </ClCompile>
     <ClCompile Include="..\..\..\..\src\zfile.c">
       <CompileAs>CompileAsCpp</CompileAs>
     </ClCompile>
diff --git a/builds/msvc/vs2010/czmq/czmq.vcxproj.filters b/builds/msvc/vs2010/czmq/czmq.vcxproj.filters
index d8a8aeaaf..2e385564e 100644
--- a/builds/msvc/vs2010/czmq/czmq.vcxproj.filters
+++ b/builds/msvc/vs2010/czmq/czmq.vcxproj.filters
@@ -43,6 +43,9 @@
     <ClCompile Include="..\..\..\..\src\zdir_patch.c">
       <Filter>src</Filter>
     </ClCompile>
+    <ClCompile Include="..\..\..\..\src\zdir_watch.c">
+      <Filter>src</Filter>
+    </ClCompile>
     <ClCompile Include="..\..\..\..\src\zfile.c">
       <Filter>src</Filter>
     </ClCompile>
diff --git a/builds/msvc/vs2012/czmq/czmq.vcxproj b/builds/msvc/vs2012/czmq/czmq.vcxproj
index c08bb4e6a..3ecac0df1 100644
--- a/builds/msvc/vs2012/czmq/czmq.vcxproj
+++ b/builds/msvc/vs2012/czmq/czmq.vcxproj
@@ -121,6 +121,9 @@
     <ClCompile Include="..\..\..\..\src\zdir_patch.c">
       <CompileAs>CompileAsCpp</CompileAs>
     </ClCompile>
+    <ClCompile Include="..\..\..\..\src\zdir_watch.c">
+      <CompileAs>CompileAsCpp</CompileAs>
+    </ClCompile>
     <ClCompile Include="..\..\..\..\src\zfile.c">
       <CompileAs>CompileAsCpp</CompileAs>
     </ClCompile>
diff --git a/builds/msvc/vs2012/czmq/czmq.vcxproj.filters b/builds/msvc/vs2012/czmq/czmq.vcxproj.filters
index d8a8aeaaf..2e385564e 100644
--- a/builds/msvc/vs2012/czmq/czmq.vcxproj.filters
+++ b/builds/msvc/vs2012/czmq/czmq.vcxproj.filters
@@ -43,6 +43,9 @@
     <ClCompile Include="..\..\..\..\src\zdir_patch.c">
       <Filter>src</Filter>
     </ClCompile>
+    <ClCompile Include="..\..\..\..\src\zdir_watch.c">
+      <Filter>src</Filter>
+    </ClCompile>
     <ClCompile Include="..\..\..\..\src\zfile.c">
       <Filter>src</Filter>
     </ClCompile>
diff --git a/builds/msvc/vs2013/czmq/czmq.vcxproj b/builds/msvc/vs2013/czmq/czmq.vcxproj
index a3b0bb573..b719d5f1f 100644
--- a/builds/msvc/vs2013/czmq/czmq.vcxproj
+++ b/builds/msvc/vs2013/czmq/czmq.vcxproj
@@ -121,6 +121,9 @@
     <ClCompile Include="..\..\..\..\src\zdir_patch.c">
       <CompileAs>CompileAsCpp</CompileAs>
     </ClCompile>
+    <ClCompile Include="..\..\..\..\src\zdir_watch.c">
+      <CompileAs>CompileAsCpp</CompileAs>
+    </ClCompile>
     <ClCompile Include="..\..\..\..\src\zfile.c">
       <CompileAs>CompileAsCpp</CompileAs>
     </ClCompile>
diff --git a/builds/msvc/vs2013/czmq/czmq.vcxproj.filters b/builds/msvc/vs2013/czmq/czmq.vcxproj.filters
index d8a8aeaaf..2e385564e 100644
--- a/builds/msvc/vs2013/czmq/czmq.vcxproj.filters
+++ b/builds/msvc/vs2013/czmq/czmq.vcxproj.filters
@@ -43,6 +43,9 @@
     <ClCompile Include="..\..\..\..\src\zdir_patch.c">
       <Filter>src</Filter>
     </ClCompile>
+    <ClCompile Include="..\..\..\..\src\zdir_watch.c">
+      <Filter>src</Filter>
+    </ClCompile>
     <ClCompile Include="..\..\..\..\src\zfile.c">
       <Filter>src</Filter>
     </ClCompile>
diff --git a/doc/Makefile.am b/doc/Makefile.am
index 92ac55399..aa52b799c 100644
--- a/doc/Makefile.am
+++ b/doc/Makefile.am
@@ -3,7 +3,7 @@
 #  Please refer to the README for information about making permanent changes.  #
 ################################################################################
 MAN1 = makecert.1
-MAN3 = zactor.3 zauth.3 zarmour.3 zbeacon.3 zcert.3 zcertstore.3 zchunk.3 zclock.3 zconfig.3 zdigest.3 zdir.3 zdir_patch.3 zfile.3 zframe.3 zgossip.3 zhashx.3 ziflist.3 zlistx.3 zloop.3 zmonitor.3 zmsg.3 zpoller.3 zproxy.3 zrex.3 zsock.3 zsock_option.3 zstr.3 zsys.3 zuuid.3 zauth_v2.3 zbeacon_v2.3 zctx.3 zhash.3 zlist.3 zmonitor_v2.3 zmutex.3 zproxy_v2.3 zsocket.3 zsockopt.3 zthread.3
+MAN3 = zactor.3 zauth.3 zarmour.3 zbeacon.3 zcert.3 zcertstore.3 zchunk.3 zclock.3 zconfig.3 zdigest.3 zdir.3 zdir_patch.3 zdir_watch.3 zfile.3 zframe.3 zgossip.3 zhashx.3 ziflist.3 zlistx.3 zloop.3 zmonitor.3 zmsg.3 zpoller.3 zproxy.3 zrex.3 zsock.3 zsock_option.3 zstr.3 zsys.3 zuuid.3 zauth_v2.3 zbeacon_v2.3 zctx.3 zhash.3 zlist.3 zmonitor_v2.3 zmutex.3 zproxy_v2.3 zsocket.3 zsockopt.3 zthread.3
 MAN7 = czmq.7
 MAN_DOC = $(MAN1) $(MAN3) $(MAN7)
 
@@ -58,6 +58,8 @@ zdir.txt:
 	zproject_mkman $@
 zdir_patch.txt:
 	zproject_mkman $@
+zdir_watch.txt:
+	zproject_mkman $@
 zfile.txt:
 	zproject_mkman $@
 zframe.txt:
@@ -118,7 +120,7 @@ makecert.txt:
 	zproject_mkman $@
 clean:
 	rm -f *.1 *.3
-	zproject_mkman zactor zauth zarmour zbeacon zcert zcertstore zchunk zclock zconfig zdigest zdir zdir_patch zfile zframe zgossip zhashx ziflist zlistx zloop zmonitor zmsg zpoller zproxy zrex zsock zsock_option zstr zsys zuuid zauth_v2 zbeacon_v2 zctx zhash zlist zmonitor_v2 zmutex zproxy_v2 zsocket zsockopt zthread makecert 
+	zproject_mkman zactor zauth zarmour zbeacon zcert zcertstore zchunk zclock zconfig zdigest zdir zdir_patch zdir_watch zfile zframe zgossip zhashx ziflist zlistx zloop zmonitor zmsg zpoller zproxy zrex zsock zsock_option zstr zsys zuuid zauth_v2 zbeacon_v2 zctx zhash zlist zmonitor_v2 zmutex zproxy_v2 zsocket zsockopt zthread makecert 
 endif
 ################################################################################
 #  THIS FILE IS 100% GENERATED BY ZPROJECT; DO NOT EDIT EXCEPT EXPERIMENTALLY  #
diff --git a/include/czmq_library.h b/include/czmq_library.h
index ea66431bd..787d4da27 100644
--- a/include/czmq_library.h
+++ b/include/czmq_library.h
@@ -74,6 +74,8 @@ typedef struct _zdir_t zdir_t;
 #define ZDIR_T_DEFINED
 typedef struct _zdir_patch_t zdir_patch_t;
 #define ZDIR_PATCH_T_DEFINED
+typedef struct _zdir_watch_t zdir_watch_t;
+#define ZDIR_WATCH_T_DEFINED
 typedef struct _zfile_t zfile_t;
 #define ZFILE_T_DEFINED
 typedef struct _zframe_t zframe_t;
@@ -145,6 +147,7 @@ typedef struct _zthread_t zthread_t;
 #include "zdigest.h"
 #include "zdir.h"
 #include "zdir_patch.h"
+#include "zdir_watch.h"
 #include "zfile.h"
 #include "zframe.h"
 #include "zgossip.h"
diff --git a/include/zdir_watch.h b/include/zdir_watch.h
new file mode 100644
index 000000000..d8e2564c3
--- /dev/null
+++ b/include/zdir_watch.h
@@ -0,0 +1,64 @@
+/*  =========================================================================
+    zdir_watch - Watch a directory tree
+
+    Copyright (c) 1991-2012 iMatix Corporation -- http://www.imatix.com                
+    Copyright other contributors as noted in the AUTHORS file.                         
+                                                                                       
+    This file is part of CZMQ, the high-level C binding for 0MQ: http://czmq.zeromq.org
+                                                                                       
+    This Source Code Form is subject to the terms of the Mozilla Public                
+    License, v. 2.0. If a copy of the MPL was not distributed with this                
+    file, You can obtain one at http://mozilla.org/MPL/2.0/.                           
+    =========================================================================
+*/
+
+#ifndef ZDIR_WATCH_H_INCLUDED
+#define ZDIR_WATCH_H_INCLUDED
+
+#ifdef __cplusplus
+extern "C" {
+#endif
+
+
+//  @warning THE FOLLOWING @INTERFACE BLOCK IS AUTO-GENERATED BY ZPROJECT!
+//  @warning Please edit the model at "api/zdir_watch.xml" to make changes.
+//  @interface
+//  Create a new zdir_watch actor instance:                       
+//                                                                
+//      zactor_t *watch = zactor_new (zdir_watch_actor, NULL);    
+//                                                                
+//  Destroy zdir_watch instance:                                  
+//                                                                
+//      zactor_destroy (&watch);                                  
+//                                                                
+//  Enable verbose logging of commands and activity:              
+//                                                                
+//      zstr_send (watch, "VERBOSE");                             
+//                                                                
+//  Subscribe to changes to a directory path:                     
+//                                                                
+//      zsock_send (watch, "ss", "SUBSCRIBE", "directory_path");  
+//                                                                
+//  Unsubscribe from changes to a directory path:                 
+//                                                                
+//      zsock_send (watch, "ss", "UNSUBSCRIBE", "directory_path");
+//                                                                
+//  Receive directory changes:                                    
+//      zsock_recv (watch, "sp", &path, &patches);                
+//                                                                
+//      // Delete the received data.                              
+//      free (path);                                              
+//      zlist_destroy (&patches);                                 
+CZMQ_EXPORT void
+    zdir_watch_actor (zsock_t *pipe, void *unused);
+
+//  Self test of this class.
+CZMQ_EXPORT void
+    zdir_watch_test (bool verbose);
+//  @end
+
+#ifdef __cplusplus
+}
+#endif
+
+#endif
diff --git a/project.xml b/project.xml
index f626966ba..64059e4bf 100644
--- a/project.xml
+++ b/project.xml
@@ -20,6 +20,7 @@
     <class name = "zdigest" />
     <class name = "zdir" />
     <class name = "zdir_patch" />
+    <class name = "zdir_watch" />
     <class name = "zfile" />
     <class name = "zframe" />
     <class name = "zgossip" />
diff --git a/src/Makemodule.am b/src/Makemodule.am
index 7dc4346b3..2a3f00cd8 100644
--- a/src/Makemodule.am
+++ b/src/Makemodule.am
@@ -30,6 +30,7 @@ include_HEADERS = \
     include/zdigest.h \
     include/zdir.h \
     include/zdir_patch.h \
+    include/zdir_watch.h \
     include/zfile.h \
     include/zframe.h \
     include/zgossip.h \
@@ -73,6 +74,7 @@ src_libczmq_la_SOURCES = \
     src/zdigest.c \
     src/zdir.c \
     src/zdir_patch.c \
+    src/zdir_watch.c \
     src/zfile.c \
     src/zframe.c \
     src/zgossip.c \
diff --git a/src/czmq_selftest.c b/src/czmq_selftest.c
index 6c669dd1d..acd4dcf5e 100644
--- a/src/czmq_selftest.c
+++ b/src/czmq_selftest.c
@@ -45,6 +45,7 @@ main (int argc, char *argv [])
     zdigest_test (verbose); 
     zdir_test (verbose); 
     zdir_patch_test (verbose); 
+    zdir_watch_test (verbose); 
     zfile_test (verbose); 
     zframe_test (verbose); 
     zgossip_test (verbose); 
diff --git a/src/zdir_watch.c b/src/zdir_watch.c
new file mode 100644
index 000000000..447a310b8
--- /dev/null
+++ b/src/zdir_watch.c
@@ -0,0 +1,398 @@
+/*  =========================================================================
+    zdir_watch - 
+    Watch a directory tree
+
+    
+
+    Copyright (c) 1991-2012 iMatix Corporation -- http://www.imatix.com                
+    Copyright other contributors as noted in the AUTHORS file.                         
+                                                                                       
+    This file is part of CZMQ, the high-level C binding for 0MQ: http://czmq.zeromq.org
+                                                                                       
+    This Source Code Form is subject to the terms of the Mozilla Public                
+    License, v. 2.0. If a copy of the MPL was not distributed with this                
+    file, You can obtain one at http://mozilla.org/MPL/2.0/.                           
+    =========================================================================
+*/
+
+/*
+@header
+    zdir_watch - 
+    Watch a directory tree
+
+    
+@discuss
+@end
+*/
+
+#include "../include/czmq.h"
+#include "czmq_classes.h"
+
+//  Structure of our class
+
+struct _zdir_watch_t {
+    zsock_t *pipe;            // actor command channel
+    zloop_t *loop;            // event reactor
+    int read_timer_id;        // the zloop timer id to signal directory updating
+
+    bool verbose;             // extra logging to be printed
+    zhash_t *subs;            // path -> sub_t instance hashtable for each active subscription
+};
+
+typedef struct _sub_t {
+    zdir_t *dir;
+} sub_t;
+
+static int
+s_on_read_timer (zloop_t *loop, int timer_id, void *arg)
+{
+    zdir_watch_t *watch = (zdir_watch_t *) arg;
+
+    for (void *data = zhash_first (watch->subs); data != NULL; data = zhash_next (watch->subs))
+    {
+        sub_t *sub = (sub_t *)data;
+
+        zdir_t *new = zdir_new (zdir_path (sub->dir), NULL);
+        if (!new)
+        {
+            if (watch->verbose)
+                zsys_error ("zdir_watch: Unable to create new zdir for path %s", zdir_path (sub->dir));
+            continue; 
+        }
+
+        // Determine if anything has changed.
+        zlist_t *diff = zdir_diff (sub->dir, new, "");
+
+        // Do memory management before error handling...
+        zdir_destroy (&sub->dir);
+        sub->dir = new;
+
+        if (!diff)
+        {
+            if (watch->verbose)
+                zsys_error ("zdir_watch: Unable to create diff for path %s", zdir_path (sub->dir));
+            continue; 
+        }
+
+        if (zlist_size (diff) > 0)
+        {
+            if (watch->verbose)
+                zsys_info ("zdir_watch: Found %d changes in %s", zlist_size (diff), zdir_path (sub->dir));
+
+            if (zsock_send(watch->pipe, "sp", zdir_path (sub->dir), diff) != 0)
+            {
+                if (watch->verbose)
+                    zsys_error ("zdir_watch: Unable to send patch list for path %s", zdir_path (sub->dir));
+                zlist_destroy (&diff);
+            }
+        }
+        else
+        {
+            if (watch->verbose)
+                zsys_info ("zdir_watch: No changes in %s", zdir_path (sub->dir));
+            zlist_destroy (&diff);
+        }
+    }
+
+    return 0;
+}
+
+
+static void
+s_zdir_watch_destroy (zdir_watch_t **watch_p)
+{
+    assert (watch_p);
+    if (*watch_p) {
+        zdir_watch_t *watch = *watch_p;
+
+        zloop_destroy (&watch->loop);
+
+        free (watch);
+        *watch_p = NULL;
+    }
+}
+
+static void
+s_sub_free (void *data)
+{
+    sub_t *sub = (sub_t *)data;
+    zdir_destroy (&sub->dir);
+
+    free (sub);
+}
+
+static void
+s_zdir_watch_subscribe (zdir_watch_t *watch, const char *path)
+{
+    if (watch->verbose)
+        zsys_info ("zdir_watch: Subscribing to directory path: %s", path);
+
+    sub_t *sub = (sub_t *) zmalloc (sizeof(sub_t));
+    sub->dir = zdir_new (path, NULL);
+
+    int rc = zhash_insert (watch->subs, path, sub);
+    if (rc)
+    {
+        if (watch->verbose)
+            zsys_error ("zdir_watch: Unable to insert path '%s' into subscription list", path);
+        zsock_signal (watch->pipe, 1);
+        return;
+    }
+
+    void *item = zhash_freefn (watch->subs, path, s_sub_free);
+    if (item != sub)
+    {
+        if (watch->verbose)
+            zsys_error ("zdir_watch: Unable to set free fn for path %s", path);
+        zsock_signal (watch->pipe, 1);
+        return;
+    }
+
+    if (watch->verbose)
+        zsys_info ("zdir_watch: Successfully subscribed to %s", path);
+    zsock_signal (watch->pipe, 0);
+}
+
+static void
+s_zdir_watch_unsubscribe (zdir_watch_t *watch, const char *path)
+{
+    if (watch->verbose)
+        zsys_info ("zdir_watch: Unsubscribing from directory path: %s", path);
+
+    zhash_delete (watch->subs, path);
+    if (watch->verbose)
+        zsys_info ("zdir_watch: Successfully unsubscribed from %s", path);
+    zsock_signal (watch->pipe, 0);
+}
+
+static int
+s_zdir_watch_timeout (zdir_watch_t *watch, int timeout)
+{
+    if (watch->verbose)
+        zsys_info ("zdir_watch: Setting directory poll timeout to %d", timeout);
+
+    if (watch->read_timer_id != -1)
+    {
+        zloop_timer_end (watch->loop, watch->read_timer_id);
+        watch->read_timer_id = -1;
+    }
+
+    watch->read_timer_id = zloop_timer (watch->loop, timeout, 0, s_on_read_timer, watch);
+
+    if (watch->verbose)
+        zsys_info ("zdir_watch: Successfully set directory poll timeout to %d", timeout);
+    return 0;
+}
+
+static zdir_watch_t *
+s_zdir_watch_new (zsock_t *pipe)
+{
+    zdir_watch_t *watch = (zdir_watch_t *) zmalloc (sizeof (zdir_watch_t));
+    if (!watch)
+        return NULL;
+    watch->pipe = pipe;
+    watch->read_timer_id = -1;
+    watch->verbose = false;
+    return watch;
+}
+
+static int
+s_on_command (zloop_t *loop, zsock_t *reader, void *arg)
+{
+    zdir_watch_t *watch = (zdir_watch_t *) arg;
+
+    zmsg_t *msg = zmsg_recv (watch->pipe);
+    assert (msg);
+    char *command = zmsg_popstr (msg);
+    assert (command);
+
+    if (watch->verbose)
+        zsys_info ("zdir_watch: Command received: %s", command);
+
+    if (streq (command, "$TERM"))
+    {
+        return -1;
+    }
+    else if (streq (command, "VERBOSE"))
+    {
+        watch->verbose = true;
+        zsock_signal (watch->pipe, 0);
+    }
+    else if (streq (command, "SUBSCRIBE"))
+    {
+        char *path = zmsg_popstr (msg);
+        if (path)
+        {
+            s_zdir_watch_subscribe (watch, path);
+            free (path);
+        }
+        else
+        {
+            if (watch->verbose)
+                zsys_error ("zdir_watch: Unable to extract path from SUBSCRIBE message");
+            zsock_signal (watch->pipe, 1);
+        }
+    }
+    else if (streq (command, "UNSUBSCRIBE"))
+    {
+        char *path = zmsg_popstr (msg);
+        if (path)
+        {
+            assert (path);
+            s_zdir_watch_unsubscribe (watch, path);
+            free (path);
+        }
+        else
+        {
+            if (watch->verbose)
+                zsys_error ("zdir_watch: Unable to extract path from UNSUBSCRIBE message");
+            zsock_signal (watch->pipe, 1);
+        }
+    }
+    else if (streq (command, "TIMEOUT"))
+    {
+        char *timeout_string = zmsg_popstr (msg);
+        if (timeout_string)
+        {
+            int timeout = atoi (timeout_string);
+            zsock_signal (watch->pipe, s_zdir_watch_timeout (watch, timeout));
+            free (timeout_string);
+        }
+        else
+        {
+            if (watch->verbose)
+                zsys_error ("zdir_watch: Unable to extract time from TIMEOUT message");
+            zsock_signal (watch->pipe, 1);
+        }
+    }
+    else
+    {
+        if (watch->verbose)
+            zsys_warning ("zdir_watch: Unknown command '%s'", command);
+        zsock_signal (watch->pipe, 1);
+    }
+
+    free (command);
+    return 0;
+}
+
+//  --------------------------------------------------------------------------
+//  Create a new zdir_watch actor instance                   
+
+void
+zdir_watch_actor (zsock_t *pipe, void *unused)
+{
+    zdir_watch_t *watch = s_zdir_watch_new (pipe);
+    assert (watch);
+
+    watch->loop = zloop_new ();
+    assert (watch->loop);
+
+    watch->subs = zhash_new ();
+    assert (watch->subs);
+
+    zloop_reader (watch->loop, pipe, s_on_command, watch);
+    zloop_reader_set_tolerant (watch->loop, pipe); // command pipe needs to be tolerant, otherwise we'd have a hard time shutting down
+
+    s_zdir_watch_timeout (watch, 250); // default poll time of 250ms
+
+    //  Signal initialization
+    zsock_signal (pipe, 0);
+
+    // Dispatch above handlers
+    zloop_start (watch->loop);
+    if (watch->verbose)
+        zsys_info ("zdir_watch: Complete");
+
+    // signal destruction
+    zsock_signal (watch->pipe, 0);
+
+    // Done - cleanup and exit
+    s_zdir_watch_destroy (&watch);
+}
+
+
+//  --------------------------------------------------------------------------
+//  Self test of this class.
+
+void
+zdir_watch_test (bool verbose)
+{
+    printf (" * zdir_watch: ");
+
+    //  @selftest
+    zactor_t *watch = zactor_new (zdir_watch_actor, NULL);
+    assert (watch);
+
+    if (verbose)
+    {
+        zsock_send (watch, "s", "VERBOSE");
+        assert (zsock_wait (watch) == 0);
+    }
+
+    zsock_send (watch, "si", "TIMEOUT", 100);
+    assert (zsock_wait (watch) == 0);
+
+    zsock_send (watch, "ss", "SUBSCRIBE", ".");
+    assert (zsock_wait (watch) == 0);
+
+    zsock_send (watch, "ss", "UNSUBSCRIBE", ".");
+    assert (zsock_wait (watch) == 0);
+
+    zsock_send (watch, "ss", "SUBSCRIBE", ".");
+    assert (zsock_wait (watch) == 0);
+
+    zfile_t *newfile = zfile_new (".", "test_abc");
+    zfile_output (newfile);
+    fprintf (zfile_handle (newfile), "test file\n");
+    zfile_close (newfile);
+
+    char *path;
+    zlist_t *patches;
+
+    // wait for notification of the file being added
+    int rc = zsock_recv (watch, "sp", &path, &patches);
+    assert (rc == 0);
+
+    assert (streq (path, "."));
+    free (path);
+
+    assert (zlist_size (patches) == 1);
+
+    zdir_patch_t *patch = zlist_pop (patches);
+    assert (streq (zdir_patch_path (patch), "."));
+
+    zfile_t *patch_file = zdir_patch_file (patch);
+    assert (streq (zfile_filename (patch_file, ""), "./test_abc"));
+
+    zdir_patch_destroy (&patch);
+    zlist_destroy (&patches);
+
+    // remove the file
+    zfile_remove (newfile);
+    zfile_destroy (&newfile);
+
+    // wait for notification of the file being removed
+    rc = zsock_recv (watch, "sp", &path, &patches);
+    assert (rc == 0);
+
+    assert (streq (path, "."));
+    free (path);
+
+    assert (zlist_size (patches) == 1);
+
+    patch = zlist_pop (patches);
+    assert (streq (zdir_patch_path (patch), "."));
+
+    patch_file = zdir_patch_file (patch);
+    assert (streq (zfile_filename (patch_file, ""), "./test_abc"));
+
+    zdir_patch_destroy (&patch);
+    zlist_destroy (&patches);
+
+    zactor_destroy (&watch);
+
+    //  @end
+
+    printf ("OK\n");
+}
